#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include <Array.au3>

;RainRGB VarName=AnyName FileName="Path\File" Alpha=0-255 or NULL Config=AnyConfig or * or NULL

If _ArraySearch($CmdLine, "VarName=",0,0,0,1) = -1 Or _ArraySearch($CmdLine, "FileName=",0,0,0,1) = -1 Then Exit

$Index1 = _ArraySearch($CmdLine, "VarName=",0,0,0,1)
$VarName = StringRight($CmdLine[$Index1], StringLen($CmdLine[$Index1]) - StringLen("VarName="))
$Index2 = _ArraySearch($CmdLine, "FileName=",0,0,0,1)
$FileName = StringRight($CmdLine[$Index2], StringLen($CmdLine[$Index2]) - StringLen("FileName="))
$Index3 = _ArraySearch($CmdLine, "Alpha=",0,0,0,1)
If $Index3 <> -1 Then
	$Alpha = StringRight($CmdLine[$Index3], StringLen($CmdLine[$Index3]) - StringLen("Alpha="))
Else
	$Alpha = ""
EndIf
$Index4 = _ArraySearch($CmdLine, "RefreshConfig=",0,0,0,1)
If $Index4 <> -1 Then
	$Config = StringRight($CmdLine[$Index4], StringLen($CmdLine[$Index4]) - StringLen("RefreshConfig="))
Else
	$Config = ""
EndIf

If $VarName = "" Then Exit
If $FileName = "" Then Exit

If FileExists("..\..\Rainmeter.exe") = 0 Then
	MsgBox("16","RainRGB Error", "RainRGB.exe must reside in " & @CRLF & @CRLF & "[RaimeterPrograDir]\Addons\RainRGB")
	Exit
EndIf

$FileVarString = IniRead($FileName, "Variables", $VarName, "")
If $FileVarString = "" Then Exit

If StringInStr($FileVarString, ",") Then
	$HexOrRGB = "R"
	$SplitFileVarString = StringSplit($FileVarString, ",")
	If $SplitFileVarString[0] = 4 Then
		If $Alpha = "" Then $Alpha = $SplitFileVarString[4]
		$FileVarString = $SplitFileVarString[1] & "," & $SplitFileVarString[2] & "," & $SplitFileVarString[3]
	EndIf

Else

	$HexOrRGB = "H"
	If $Alpha <> "" Then
		$Alpha = StringRight(hex($Alpha),2)
	Else
		If StringLen($FileVarString) = 8 Then
			$Alpha = StringRight($FileVarString, 2)
			$FileVarString = StringLeft($FileVarString, 6)
		ElseIf StringLen($FileVarString) > 8 Then
			$Alpha = StringRight($FileVarString, StringLen($FileVarString)-6)
		Else
			$Alpha = ""
		EndIf
	EndIf

EndIf

If $HexOrRGB = "R" Then
	$CurrentColor = "0x" & StringRight(hex($SplitFileVarString[1]),2) & StringRight(hex($SplitFileVarString[2]),2) & StringRight(hex($SplitFileVarString[3]),2)
Else
	$CurrentColor = "0x" & StringLeft($FileVarString, 6)
EndIf

$GUIHidden = GUICreate("RainRGB", 463, 337, -1, -1)
$PickedColor = _ChooseColor(2, $CurrentColor, 2, $GUIHIdden)
If $PickedColor = -1 Then Exit
If $HexOrRGB = "H" Then $ReturnColor = StringRight($PickedColor, 6)
If $HexOrRGB = "R" Then $ReturnColor = dec(StringMId($PickedColor, 3,2)) & "," & dec(StringMid($PickedColor, 5,2)) & "," & dec(StringRight($PickedColor,2))

If $HexOrRGB = "H" Then
	IniWrite($FileName, "Variables", $VarName, $ReturnColor & $Alpha)
Else
	If $Alpha <> "" Then IniWrite($FileName, "Variables", $VarName, $ReturnColor & "," & $Alpha)
	If $Alpha = "" Then IniWrite($FileName, "Variables", $VarName, $ReturnColor)
EndIf

ShellExecute("..\..\Rainmeter.exe", "!RainmeterRefresh " & $Config)
